pub mod registry;
pub mod docker_hub;

/// query args
pub struct QueryArgs {
    pub namespace: String,
    pub repository: String,
    pub name: Option<String>,
    pub arch: Option<String>,
}

pub trait DockerTagsFetcher {
    /// query tags
    fn get_tags(&self, args: &QueryArgs) -> Vec<String>;
}

impl QueryArgs {
    pub fn new(repository: &str, name: Option<String>, arch: Option<String>) -> Self {
        let mut repository = repository;
        let mut namespace = "library";
        let option = repository.find('/');
        if option.is_some() {
            namespace = &repository[0..option.unwrap()];
            repository = &repository[(option.unwrap() + 1)..];
        }
        Self {
            namespace: String::from(namespace),
            repository: String::from(repository),
            name,
            arch,
        }
    }
}
